
define("index",["jquery","Handlebars","commonApp","config","tool","./modules/tab"],function(require,exports,module){
	var $ = require("jquery");
	var Handlebars = require("Handlebars");
	var commonApp = require("commonApp");
	var config = require("config");
	var Tool = require("tool");
	var Tab = require("./modules/tab");
	var dataUrl = api_url;
	var windowScrollTop = new Array();
	//var ls = window.localStorage;

	var appIndex = {
		topflag:false,
		scroll:0,
		isAnimate:false,
		longtime:1,
		longtimeTimeout:null,
		validateTimeout:null,
		tabObject:null,
		isFinanceAnimate:false,
		bannerList:null,
		contractList:null,
		addDataNow:false,
		bannerSlider:"",		
		isReload:false,
		allPage:1,
		fixOffsetTop:0,
		newslistDateArray:[],
		tab:{
			gold:{	//黄金资讯
				reloadTime:5,
				nowTime:0,
				isShow:false,
				page:0,
				url:"/Cj/Api/index",
				name:"黄金资讯"
			},
			finance:{	//财经日历
				reloadTime:5,
				nowTime:0,
				isShow:false,
				page:0,
				url:"",
				name:"财经日历"
			}
		},
		init:function(){
			//设置链接超时大于10秒判断没有网络
			$.ajaxSetup({
				timeout:10000,error:function(xmlRequest,textStatus,errorThrown){
					if(textStatus=="timeout"){
						//断网了
						$("#no_wifi").show();
						$("#no_data").hide();
					}					
				}
			});
			this.setScrollHeight();
			if(!navigator.onLine){
				//无网络
				$("#no_wifi").show();
				$("#no_data").hide();
			}else{
				$("#no_wifi").hide();
				$("#no_data").show();				
				this.loadLocalStorageData();
				this.requestData();
				this.bindLongTouch();
				this.bindScroll();
			}
		},
		initTab:function(){
			var self = this;
			self.tab["gold"].page=0;

			//纸条互动tab
			self.tabObject = new Tab($("#news_ul li"),$("div[id^='news_']"),[
					function(){self.loadnewslist("gold")},
					function(){self.finance()}			
				],{
				curTab:0,
				activeClass:"title_sel",
				hideClass:"hidden",
				showClass:"show",
				autoInit:true,
				initContentAlways:true
			});
		},
		bindScroll:function(){
			var windowHeight = $(window).height();
			$("#top").bind("click",function(){
				var nowTop = $(window).scrollTop();
				var tmpStepTop = nowTop/100;
				var tmpTopSetInterval = setInterval(function(){
					var tmp = $(window).scrollTop()-tmpStepTop;
					if(tmp<=0){
						tmp=0;
					}
					$(window).scrollTop(tmp);
					if(tmp==0){
						clearInterval(tmpTopSetInterval);
					}
				},10);
			});

			var self = this;
			var startY,startTime,startScrollTop,endY,endTime,moveY,loadVal=5,isFan=false,maxDown=50,infoCont=false;			

			$(document).on("touchstart",function(e){				
				startY = e.originalEvent.touches[0].clientY;
		        startTime = new Date().valueOf();
		        startScrollTop = $(window).scrollTop();
		        self.scroll = $(".scroll").height();
			}).on("touchend",function(e){
		        if(self.isReload){		        	
		        	self.requestData();
		        	$(".loadup").hide();
		        	$(".reloadtext").text("正在刷新...");
		        	$(".loadpic").css("display","inline-block");
		            $(".loadpic").addClass("loadTran");
		            self.isReload=false;
		            setTimeout(function(){
		                $(".content").animate({
		                	"top":"-30px"},1000,function(){
				                $(".loadpic").hide();
				                $(".loadup").show().removeClass("loadupFan");
		                	});
		            },1500);
		        }
			}).on("touchmove",function(e){				
				var moveY = e.originalEvent.touches[0].clientY-startY;
				if($(window).scrollTop()==0&&moveY*1>loadVal&&moveY<=maxDown){
					e.preventDefault();
					$(".content").css("top",moveY-30);
			        if(moveY>10){
			            $(".reloadtext").text("松开即刷新...");
			            isFan=true;
			        }else{
			            $(".reloadtext").text("下拉可以刷新...");
			            isFan=false;
			        };
			        if(isFan){
			            $(".loadup").addClass("loadupFan");
			        }else{
			            $(".loadup").removeClass("loadupFan");
			        }
			        self.isReload=true;
				}				
			});

			$(document).scroll(function(){
				if(windowScrollTop.length<=5){
					windowScrollTop.push($(window).scrollTop());
				}else{
					windowScrollTop.shift();
					windowScrollTop.push($(window).scrollTop());
				}
				if($(window).scrollTop()>=$(".scroll").height()){
					if(!self.topflag&&!infoCont){
						self.showFixed();
						self.isFixDate();
					}			
				}else{
					infoCont = false;
					if(self.topflag){						
						self.removeFixed();
						self.isFixDate();
					}
				}				

				//下拉刷新加载数据
				if($("#news_gold").css("display")!="none"&&!self.addDataNow&&windowScrollTop.length>=5&&windowScrollTop[4]>windowScrollTop[3]){
					self.addnewslistData("gold");
				}

				if($(window).scrollTop()>=windowHeight){
					$("#top").fadeIn();
				}else{
					$("#top").fadeOut();
				}
			})

			var newsStartY,newsEndY,newsStartTime,newsEndTime,newsMoveY =new Array();
			$(".news_info").on("touchstart",function(e){
				infoCont = true;
				newsStartY = e.originalEvent.touches[0].clientY*1;
		        newsStartTime = new Date().valueOf();
		        newsMoveY =new Array();
		        newsMoveY.push(newsStartY);
			}).on("touchend",function(e){
				newsEndY = e.originalEvent.changedTouches[0].clientY*1;
		        newsEndTime = new Date().valueOf();

		        var tmpY = newsEndY - newsMoveY[newsMoveY.length-1];
		        if(tmpY==0&&newsMoveY.length>1){
		        	tmpY = newsMoveY[newsMoveY.length-1]-newsMoveY[newsMoveY.length-2];
		        }
		        if(tmpY>0){
					self.removeFixed();
					self.isFixDate();
				}else if(tmpY<0){
					self.showFixed();
					self.isFixDate();
				}
				
				newsMoveY =new Array();
			}).on("touchmove",function(e){				
				if(newsMoveY.length<=3){
					newsMoveY.push(e.originalEvent.touches[0].clientY*1);
				}else{
					newsMoveY.shift();
					newsMoveY.push(e.originalEvent.touches[0].clientY*1);
				}
				var moveLength =newsMoveY.length;
				if(moveLength>1){
					if(newsMoveY[moveLength-1]*1-newsMoveY[moveLength-2]*1>0){
						self.removeFixed();
						self.isFixDate();
					}else if(newsMoveY[moveLength-1]*1-newsMoveY[moveLength-2]*1<0){
						self.showFixed();
						self.isFixDate();
					}
				}				
			})
		},
		showFixed:function(obj){
			if($(window).scrollTop()>=$(".scroll").height()){
				var fix_title = $(".news_div .title");
				fix_title.addClass("fixed");  
				$(".news_info").css("margin-top",fix_title.height()+2);
				this.topflag = true;
			}
		},
		removeFixed:function(){
			var fix_title = $(".news_div .title");
			fix_title.removeClass("fixed");  
			$(".news_info").css("margin-top",0);
			this.topflag = false;
		},
		bindLongTouch:function(){
			var self = this;
			var tmpClass = -1;
			$(".live_room .roomitem").bind("click",function(){
				self.openLiveRoom(this);
			});
			var longmove = false;
			var stX,stY,edX,edY;

			$(".longTouch").bind("touchstart",function(e){
				//e.preventDefault();
				stX = e.originalEvent.touches[0].clientX;
				stY = e.originalEvent.touches[0].clientY;

				tmpClass = $(this).attr("data-shadow");
				self.longtime=0;
				self.longtimeTimeout = setTimeout(function(){
					self.isLongTouch(tmpClass);
				},1000);
				self.validateTimeout=self.longtimeTimeout;
			}).bind("touchend",function(e){
				edX = e.originalEvent.changedTouches[0].clientX;
				edY = e.originalEvent.changedTouches[0].clientY;
				if((Math.abs(edX-stX)<=5)&&(Math.abs(edY-stY)<=5)){
					longmove = false;
				}else{
					longmove = true;
				}
				if(!longmove){
					e.preventDefault();				
					if(self.longtime==0){
						self.longtime=1;
						//alert("点击，执行点击代码");
						tmpClass = $(this).attr("data-shadow");
						var code = $(".market .item").eq(tmpClass).attr("data-code");
						var json = {
							pid:102,
							code:code,
							name:$(".market .item").eq(tmpClass).find("h1").text()
						}
						if(code!=null&&code!=undefined&&code!=""){
							commonApp.TakingApp("openAppPage",json);
						}                	
					}
				}				
				self.longtime=1;
				clearTimeout(self.longtimeTimeout);
				longmove = false;
			}).bind("touchmove",function(e){
				//longmove = true;
			});
		},
		isLongTouch:function(i){
			if(this.longtime==0&&this.longtimeTimeout==this.validateTimeout&&!this.isReload){
				//alert("长按了1秒，执行长按代码");
				this.longtime=1;
				var code = $(".market .item").eq(i).attr("data-code");
				var json ={
					pid:106,
					code:code
				}
				if(code!=null&&code!=undefined&&code!=""){
					commonApp.TakingApp("openAppPage",json);
				}
			}
		},
		loadData:function(key){			
			this.loadbannerlist(key);
		},
		loadbannerlist:function(key){
			//alert("加载banner请求数据")
			//初始化状态
			
			$(".banner").width($(".banner img").width());
			$(".banner").height($(".banner img").height())

			//加载首页banner图片
			var self = this;
			var url = dataUrl+"/zbs/index/homepage?callback=?";
			var data = {ukey:key};
			$.getJSON(url,data,function(data){
				//alert("加载banner请求数据完成");
				if(data.code==1){
					if(data.result!=null&&data.result!=undefined){
						if(data.result.banner!=null&&data.result.banner!=undefined){
							self.bannerList = data.result.banner;
							if($(".banner ul").html()!=""&&self.bannerList.length>0){
								$(".banner").html("<ul></ul>");
								$(".banner ul").html(Handlebars.compile($("#bannerTemplate").html())(data.result));

								if(self.bannerSlider!=""){
									self.bannerSlider.stop();
								}
								var blength = self.bannerList.length;
								//生成点原点
								if(blength>1){
									var tmpPoint = $("<div>").addClass("point");
						            for(var i=0;i<blength;i++){
						                tmpPoint.append($("<div>"));
						            }
						            $(".banner ul").after(tmpPoint);
						            var p_width = $(".banner .point").width();
						            tmpPoint.css({"left":(-1*p_width/2)+"px","bottom":"5px"});
						            tmpPoint.find("div").eq(0).addClass("sel");									
								}

								self.bannerSlider = Swipe(document.getElementById("scroll_img"),{
									auto:3000,continuous: true,stopPropagation:true,transitionEnd:function(i,ele){
										if(self.bannerList.length>1){
											tmpPoint.find("div").removeClass("sel");
											if(blength<3){
												i = i%2;
											}
											tmpPoint.find("div").eq(i).addClass("sel");
										}
									}
								});
							}
						}
						if(data.result.contract!=null&&data.result.contract!=undefined){							
							self.contractList = data.result.contract;							
							self.loadmarketcode(self.contractList);
						}
						if(data.result.room!=null&&data.result.room!=undefined){
							var liveroom=null,wordroom=null;
							for(var i=0;i<data.result.room.length;i++){
								var category = data.result.room[i].category*1;
								if(category==2&&liveroom==null){
									liveroom = data.result.room[i];
								}else if(category==1&&wordroom==null){
									wordroom = data.result.room[i];
								}
							}
							if(liveroom!=null){
								Tool.setCookie("live_id",liveroom.id);
								Tool.setCookie("live_is_common",liveroom.is_common);
								Tool.setCookie("live_category",liveroom.category);
								Tool.setCookie("live_status",liveroom.status);
								Tool.setCookie("live_room_name",liveroom.room_name);
								Tool.setCookie("live_auth_code",liveroom.auth_code);
								Tool.setCookie("live_video_home_id",liveroom.video_home_id);
								Tool.setCookie("live_room_desc",liveroom.room_desc);
								Tool.setCookie("live_online_num",liveroom.online_num);
								Tool.setCookie("live_room_mobile_icon",liveroom.room_mobile_icon);

								/*ls.setItem("live_id",liveroom.id);
								ls.setItem("live_is_common",liveroom.is_common);
								ls.setItem("live_category",liveroom.category);
								ls.setItem("live_status",liveroom.status);
								ls.setItem("live_room_name",liveroom.room_name);
								ls.setItem("live_auth_code",liveroom.auth_code);
								ls.setItem("live_video_home_id",liveroom.video_home_id);
								ls.setItem("live_room_desc",liveroom.room_desc);
								ls.setItem("live_online_num",liveroom.online_num);
								ls.setItem("live_room_mobile_icon",liveroom.room_mobile_icon);*/
							}
							
							//缓存图片的url（上）base64无法跨域
							/*Tool.urlImageToBase64(liveroom.room_mobile_icon,function(imgBase){
								ls.setItem("live_room_mobile_icon",imgBase);
							});*/							
							
							if(wordroom!=null){
								Tool.setCookie("word_id",wordroom.id);
								Tool.setCookie("word_is_common",wordroom.is_common);
								Tool.setCookie("word_category",wordroom.category);
								Tool.setCookie("word_status",wordroom.status);
								Tool.setCookie("word_room_name",wordroom.room_name);
								Tool.setCookie("word_auth_code",wordroom.auth_code);
								Tool.setCookie("word_video_home_id",wordroom.video_home_id);
								Tool.setCookie("word_room_desc",wordroom.room_desc);
								Tool.setCookie("word_online_num",wordroom.online_num);
								Tool.setCookie("word_room_mobile_icon",wordroom.room_mobile_icon);

								/*ls.setItem("word_id",wordroom.id);
								ls.setItem("word_is_common",wordroom.is_common);
								ls.setItem("word_category",wordroom.category);
								ls.setItem("word_status",wordroom.status);
								ls.setItem("word_room_name",wordroom.room_name);
								ls.setItem("word_auth_code",wordroom.auth_code);
								ls.setItem("word_video_home_id",wordroom.video_home_id);
								ls.setItem("word_room_desc",wordroom.room_desc);
								ls.setItem("word_online_num",wordroom.online_num);
								ls.setItem("word_room_mobile_icon",wordroom.room_mobile_icon);*/
							}							
							/*Tool.urlImageToBase64(wordroom.room_mobile_icon,function(imgBase){
								ls.setItem("word_room_mobile_icon",imgBase);
							});*/

							$("#video_room").html(Handlebars.compile($("#videoTemplate").html())(liveroom));
							$("#word_room").html(Handlebars.compile($("#wordTemplate").html())(wordroom));
							
							self.setLiveroomImgHeight();
						}
					}
					//$(".banner").slider({touch:true});
					$(".news_div").show();	
					$("#no_wifi").hide();
					$("#no_data").hide();
				}else{
					//alert("请求banner失败");
					alert("请下拉刷新，尝试重新加载！");
				}
			})
		},
		loadmarketcode:function(obj){
			var code = new Array();
			$(".market .item").each(function(i,item){
				if(obj[i]!=null&&obj[i]!=undefined&&obj[i].contract!=null&&obj[i].contract!=undefined&&obj[i].market!=null&&obj[i].market!=undefined){
					$(item).attr("data-code",obj[i].contract+"."+obj[i].market);
					$(item).find("h1").text(obj[i].name);
				}				
			});
			for(var i=0;i<obj.length;i++){
				var a = obj[i].contract;
				code.push(a+"."+obj[i].market)
			}
			//加载行情代码
			var json = {
				code:code,
				fun:"appIndex.updatemarketInfo"
			}
			if(code!=null&&code!=undefined&&code!=""){
				commonApp.TakingApp("varietyDate",json);
			}			
		},
		updatemarketInfo:function(obj){
			var self = this;
			for(var i=0;i<self.contractList.length;i++){
				var item = $(".market div[data-code='"+self.contractList[i].contract+"."+self.contractList[i].market+"']");
				var tmpObj = obj[self.contractList[i].contract+"."+self.contractList[i].market];
				if(tmpObj==null||tmpObj==undefined){
					continue;
				}
				var code = tmpObj.code.split(".")[0];
				/*if(self.contractList[i].name!=null&&self.contractList[i].name!=undefined&&self.contractList[i].name!=""){
					item.find("h1").text(self.contractList[i].name);
				}*/
				if(tmpObj.price!=null&&tmpObj.price!=undefined&&(tmpObj.price!=""||tmpObj.price==0)){					
					item.find(".now_price").text(tmpObj.price);
				}else{
					item.find(".now_price").text("--.--");
				}
				if(tmpObj.update_price!=null&&tmpObj.update_price!=undefined&&(tmpObj.update_price!=""||tmpObj.update_price==0)){
					item.find(".pre").text(tmpObj.update_price);
				}else{
					item.find(".pre").text("--.--");
				}
				if(tmpObj.update_percent!=null&&tmpObj.update_percent!=undefined&&(tmpObj.update_percent!=""||tmpObj.update_percent==0)){
					item.find(".precent").text(tmpObj.update_percent+"%");
				}else{
					item.find(".precent").text("--.--%");
				}
				
				/*if(tmpObj.type*1==1){
					item.removeClass("up").removeClass("down");
					var shadow = $(".market .shadow_"+i);
					shadow.removeClass("upbg").removeClass("downbg").css("opacity",0);
					(function($dom,$dom1){
						setTimeout(function(){							
							$dom1.addClass("up");
							$dom.addClass("upbg").stop().animate({
								"opacity":1
							},300,function(){
								$dom.stop().animate({"opacity":0},700)
							});						
						},5);
					})(shadow,item);					
				}else if(tmpObj.type*1==0){
					item.removeClass("up").removeClass("down");
					var shadow = $(".market .shadow_"+i);
					shadow.removeClass("upbg").removeClass("downbg").css("opacity",0);
					(function($dom,$dom1){
						setTimeout(function(){
							$dom1.addClass("down");
							$dom.addClass("downbg").stop().animate({
								"opacity":1
							},300,function(){
								$dom.stop().animate({"opacity":0},700)
							});							
						},5);
					})(shadow,item);
				}*/
				if(tmpObj.update_price>0){
					//红色
					item.removeClass("up").removeClass("down").removeClass("equal");
					var shadow = $(".market .shadow_"+i);
					shadow.removeClass("upbg").removeClass("downbg").css("opacity",0);
					(function($dom,$dom1){
						setTimeout(function(){							
							$dom1.addClass("up");		
						},5);
					})(shadow,item);
				}else if(tmpObj.update_price==0){
					//灰色
					item.removeClass("up").removeClass("down").removeClass("equal");
					var shadow = $(".market .shadow_"+i);
					shadow.removeClass("upbg").removeClass("downbg").css("opacity",0);
					(function($dom,$dom1){
						setTimeout(function(){							
							$dom1.addClass("equal");		
						},5);
					})(shadow,item);
				}else{
					//绿色
					item.removeClass("up").removeClass("down").removeClass("equal");
					var shadow = $(".market .shadow_"+i);
					shadow.removeClass("upbg").removeClass("downbg").css("opacity",0);
					(function($dom,$dom1){
						setTimeout(function(){							
							$dom1.addClass("down");		
						},5);
					})(shadow,item);
				}
			}
			var tmpmarket = $(".market").html();
		},
		formatStr:function(num){
			if(num.toString().split(".").length>1){
				if(num.toString().split(".")[1].length==1){
					num = num+"0";
				}else{
					num = num+"";
				}
			}else{
				num = num+".00";
			}
			return num;
		},
		loadliveroom:function(obj){
			//加载直播室
			var ukey = ""
			if(obj!=null&&obj!=undefined&&obj.ukey!=undefined){
				ukey = obj.ukey;
			}
			if(obj!=null&&obj!=undefined&&obj.environment!=undefined){
				getEnvironment(obj.environment);
				dataUrl = api_url;
			}
			this.loadData(ukey);
			this.initTab();
		},
		loadnewslist:function(obj){
			var self = this;
			var i = 0;
			var eqi = 0;
			for(var tmp in this.tab){
				self.tab[tmp].isShow = false;
				if(tmp==obj){
					this.tab[obj].isShow = true;
					eqi = i;
				}
				i++;
			}
			$("div[id^='news_']").removeClass("show").addClass("hidden");
			$("#news_"+obj).removeClass("hidden").addClass("show");
			$("#news_ul li").removeClass("title_sel");
			$("#news_ul li").eq(eqi).addClass("title_sel");
			/*if(this.tab[obj].nowTime==0){
				//初次加载				
				this.tab[obj].nowTime = Date.parse(new Date());
				this.addnewslistData(obj);
			}else{
				//判断是否超过重新加载时间
				var tmpNowTime = Date.parse(new Date());
				if(this.tab[obj].reloadTime<=(tmpNowTime-this.tab[obj].nowTime)/1000/60){
					//重新加载数据
					this.addnewslistData(obj);
				}else{
					//不做操作
					this.addnewslistData(obj);
				}
			}*/

			this.addnewslistData(obj);
		},
		addnewslistData:function(obj){
			//加载资讯
			var self = this;
			self.addDataNow = true;
			var url = dataUrl+self.tab[obj].url+"?callback=?";
			self.tab[obj].page = self.tab[obj].page*1+1;
			if(self.allPage<self.tab[obj].page){				
				$("#loadmoredata img").hide();
				$("#loadmoredata span").text("没有更多资讯了...");
				$("#loadmoredata").show();
				setTimeout(function(){							
					$("#loadmoredata").hide();
				},1000)
				return;
			}
			var data = {
				live_status:2,
				page:self.tab[obj].page
			};
			$("#loadmoredata img").show();
			$("#loadmoredata span").text("数据加载中...");
			$("#loadmoredata").show();
			$.getJSON(url,data,function(data){
				self.addDataNow = false;
				if(data.code==1){
					//$(window).scrollTop(windowScrollTop[windowScrollTop.length-2]);						
					data.result.name = self.tab[obj].name;
					if(data.result.article!=null&&data.result.article!=undefined){
						var calResult = self.calculateNewsDate(data.result);
						if(self.tab[obj].page*1==1){
							$("#news_"+obj+" ul").html(Handlebars.compile($("#newslistTemplate").html())(calResult));
						}else{
							$("#news_"+obj+" ul").append(Handlebars.compile($("#newslistTemplate").html())(calResult));
						}						
						$("#news_"+obj+" li + .date").each(function(i,item){
							$(item).prev().find(".info").css("border",0);
						});
						self.allPage = data.result.page_info.page_sum*1;
					}else{
						if(self.tab[obj].page*1==1){
							$("#news_"+obj+" ul").html(Handlebars.compile($("#newslistNoTemplate").html())(data.result));
							if(data.result.page_info.page==0){
								$("#loadmoredata img").hide();
								$("#loadmoredata span").text("没有更多资讯了...")
								setTimeout(function(){							
									$("#loadmoredata").hide();
								},1000)
							}
						}else{
							$("#loadmoredata img").hide();
							$("#loadmoredata span").text("没有更多资讯了...")
							setTimeout(function(){							
								$("#loadmoredata").hide();
							},1000)
						}											
					}
				}else{
					$("#loadmoredata img").hide();
					$("#loadmoredata span").text("没有更多资讯了...")
					setTimeout(function(){							
						$("#loadmoredata").hide();
					},1000)
				}
			})
		},
		calculateNewsDate:function(obj){
			var nowDay = new Date();
			nowDay = nowDay.getFullYear()+"-"+((nowDay.getMonth()*1+1)>10?(nowDay.getMonth()*1+1):"0"+(nowDay.getMonth()*1+1))+"-"+(nowDay.getDate()>10?nowDay.getDate():"0"+nowDay.getDate());
			var endDate = Tool.getEndDate(nowDay,1,0);
			for(var i=0;i<obj.article.length;i++){
				var tmpTime = obj.article[i].timesc.substring(0,10);
				if(this.newslistDateArray.indexOf(tmpTime)<0){
					this.newslistDateArray.push(tmpTime);
					if(endDate==tmpTime.replace(/\-/g,"")){
						obj.article[i].TodayDate = "昨天"; //昨天
					}else if(nowDay==tmpTime){
						//obj.article[i].TodayDate = "今天";
					}else{	
						obj.article[i].TodayDate = tmpTime.substring(5,10);
					}
				}
			}
			return obj;
		},
		requestData:function(){
			this.allPage = 1;
			this.newslistDateArray = new Array();
			this.getUKey();
		},
		getUKey:function(){
			var json = {
				fun:"appIndex.loadliveroom"
			};
			commonApp.TakingApp("getUkey",json);
		},
		gotocontentpage:function(id){
			var json={
				url:dataUrl+"/news/mobile/news.html?id="+id
			}
			commonApp.TakingApp("openWeb",json);
		},
		finance:function(){
			$("#loadmoredata").hide();
			//初始化监听
			var self = this;
			for(var tmp in this.tab){
				self.tab[tmp].isShow = false;
			}
			self.tab["finance"].isShow = true;

			var nowdate = new Date();
			var y = nowdate.getFullYear();
			var m = nowdate.getMonth() + 1;
			var d = nowdate.getDate();
			if (m <= 9) {
				m = "0" + m;
			}
			if (d <= 9) {
				d = "0" + d;
			}
			var tmpDate = y + "" + m + "" + d;
			//生成日期列表 共计21天
			setTimeout(function(){
				self.createdate(y+"-"+m+"-"+d);
				self.isFixDate();
			},0);
			
		},
		createdate:function(date){
			var dayList = new Array;
			var d_width = $(window).width()*0.94;
			var nowday = new Date(date);
			var nowweekday = nowday.getDay();
			var self = this;
			var width_m = 0.142857143;
			for(var i=6+nowweekday;i>=1;i--){
				var tmpDay = Tool.getEndDate(date,i,0);
				var day = {
					year:tmpDay.substr(0,4),
					month:tmpDay.substr(4,2),
					day:tmpDay.substr(6,2),
					weekday:Tool.getWeekDay(tmpDay.substr(0,4)+"-"+tmpDay.substr(4,2)+"-"+tmpDay.substr(6,2)),
					width:d_width*width_m,
					height:d_width*width_m*0.8*0.9/2
				}
				dayList.push(day);
			}
			var dateSplit = date.split("-");
			var day = {
				year:dateSplit[0],
				month:dateSplit[1],
				day:dateSplit[2],
				weekday:"今天",
				width:d_width*width_m,
				height:d_width*width_m*0.9/2
			}
			$(".finance_month").html(day.month+"月").css("margin-left",d_width*0.065+"px");
			dayList.push(day);
			for(var i=1;i<=14-nowweekday;i++){
				var tmpDay = Tool.getEndDate(date,i,1);
				var day = {
					year:tmpDay.substr(0,4),
					month:tmpDay.substr(4,2),
					day:tmpDay.substr(6,2),
					weekday:Tool.getWeekDay(tmpDay.substr(0,4)+"-"+tmpDay.substr(4,2)+"-"+tmpDay.substr(6,2)),
					width:d_width*width_m,
					height:d_width*width_m*0.8*0.9/2
				}
				dayList.push(day);
			}
			$("#finance_date").width(d_width*width_m*21+1).css("left",d_width*width_m*(-6.75)+"px");
			$("#finance_date").html(Handlebars.compile($("#financeDateTemplate").html())(dayList));
			

			this.ontouchdate();
			this.loadfinancelist(date.replace(/-/g,""));	

			$.each($("#finance_date li"),function(i,n){				
				$(this).bind("click",function(event){
					self.seldate($(this).attr("data-date"));
					event.preventDefault();
				})
			})		

			$(".left_btn").css({
				"height":$("#finance_date").height()+"px",
				"width":d_width*width_m/2+"px",
				"top":$(".finance_month").height()+"px",
				"left":0
			});
			$(".right_btn").css({
				"height":$("#finance_date").height()+"px",
				"width":d_width*width_m*0.8/2+"px",
				"top":$(".finance_month").height()+"px",
				"left":$(window).width()-d_width*width_m*0.8/2+"px"
			});
		},
		seldate:function(obj){
			var haveSeldate = $("#finance_date li[class*='seldate']").attr("data-date");			
			if(haveSeldate==obj){
				return;
			}
			var tmpH = $(window).width()*0.94*0.142857143*0.9/2;
			$("#finance_date li").removeClass("seldate").find(".day").height(tmpH*0.8).css("line-height",tmpH*0.8+"px");
			$("#finance_date li[data-date='"+obj+"']").addClass("seldate");			
			$("#finance_date li[data-date='"+obj+"']").find(".day").height(tmpH).css("line-height",tmpH+"px");
			var month = obj.substr(4,2);
			$(".finance_month").text(month+"月");
			this.loadfinancelist(obj);
		},
		loadfinancelist:function(date){			
			$(".datediv").html(date.substr(0,4)+"-"+date.substr(4,2)+"-"+date.substr(6,2));
			var self = this;
			var data = {};
			data.date= date;

			$(".financelist").html("");
			self.isFixDate();
			var tmpH = $(window).height();
			$("#dataList").html('<li style="text-align:center;border:0;min-height:'+tmpH+'px;"><img style="width:25px" src="../images/load.png" class="loadTran" alt=""><span style="vertical-align:text-bottom;margin-left:8px;">数据加载中...</span></li>');
			
			$(window).scrollTop($(".scroll").height());
			
			//财经日历
			$.ajax({
				url:dataUrl+"/Cj/Api/dateInfo?callback=?",
				type:"get",
				dataType:"json",
				data:data,
				success:function(data){
					if(data.code==1){
						data.result.date = date;						
						$("#dataList").html(Handlebars.compile($("#financeDataTemplate").html())(data.result));
						$("#data-T").html(Handlebars.compile($("#financeEventTemplate").html())(data.result));
						$("#data-Y").html(Handlebars.compile($("#publishTemplate").html())(data.result));
						if((data.result.dataList==null||data.result.dataList==undefined)&&(data.result.dataT==null||data.result.dataT==undefined)&&(data.result.dataY==null||data.result.dataY==undefined)){
							$("#financelistnodata").show();
						}else{
							$("#financelistnodata").hide();
						}
						//$(window).scrollTop(windowScrollTop[windowScrollTop.length-2]);
					}else{
						//alert(data.message);
					}
					$("#dataloading").hide();
				},
				error:function(){
					$("#dataloading").hide();
				}
			})
		},
		isFixDate:function(){
			//固定表头
			var fixH = $("#news_ul").height()+2;
			var f_headH =$(".finance_head").height();
			if(this.topflag&&this.tab["finance"].isShow){
				//表示需要固定表头
				$(".finance_head").css({
					"position":"fixed",
					"top":fixH+"px"
				});
				var tmpHeight = f_headH*1;
				$(".finance_content").css({
					"margin-top":tmpHeight+"px"
				})
			}else{
				$(".finance_content").css({
					"margin-top":"0"
				});
				$(".finance_head").css({
					"position":"relative",
					"top":0
				});
			}
		},
		ontouchdate:function(){
			var startpointX=0;
			var starttime=0;			
			var endpointX=0;
			var endtime=0;
			var tmpNowLeft=0;
			var self = this;			
			$("#finance_date").bind("touchstart",function(e){
				if(self.isFinanceAnimate){
					return;
				}
				startpointX = e.originalEvent.touches[0].clientX;
				tmpNowLeft = parseInt($("#finance_date").css("left").replace("px",""));
				starttime = new Date().valueOf();
			}).bind("touchend",function(e){
				if(self.isFinanceAnimate){
					return;
				}
				endpointX = e.originalEvent.changedTouches[0].clientX;
				endtime = new Date().valueOf();				
				var date_width = $(window).width()*0.94;
				now_left = tmpNowLeft*1;
				var new_left_tmp ="";
				var time = parseInt(endtime - starttime);
				var s = Math.abs(parseInt(endpointX-startpointX));
				if(endpointX-startpointX>0&&((endpointX-startpointX>=date_width/2)||(s>5&&s/time>0.3))){
					now_left = now_left+date_width;
				}
				if(endpointX-startpointX<0&&(((endpointX-startpointX)*(-1)>=date_width/2)||(s>5&&s/time>0.3))){
					now_left = now_left-date_width;					
				}
				new_left_tmp = now_left+"px";				
				if(now_left>20||now_left<date_width*(-2)-10||s==0){
					new_left_tmp = tmpNowLeft+"px";
				}
				self.isFinanceAnimate = true;
				$("#finance_date").animate({left:new_left_tmp},500,function(){
					self.isFinanceAnimate = false;
					var tmp_left = parseInt($("#finance_date").css("left").replace("px",""));
					if(tmp_left>=-5){
						$(".left_btn i").css("display","none");
						$(".right_btn i").css("display","inline-block");
						self.selectdate(0);
					}else if(tmp_left<=date_width*(-2)+20){
						$(".right_btn i").css("display","none");
						$(".left_btn i").css("display","inline-block");
						self.selectdate(2);
					}else{
						$(".left_btn i").css("display","inline-block");
						$(".right_btn i").css("display","inline-block");
						self.selectdate(1);
					}
				});
			}).bind("touchmove",function(e){
				e.preventDefault();
				if(self.isFinanceAnimate){
					return;
				}
				var movepointX = e.originalEvent.touches[0].clientX;
				var s = parseInt(movepointX-startpointX);				
				var moveTmp = tmpNowLeft*1+s*1;
				$("#finance_date").css("left",(moveTmp)+"px");
			})
			//左右按钮绑定事件
			$(".left_btn").bind("click",function(){
				self.onLeftFinanceData();
			});
			$(".right_btn").bind("click",function(){
				self.onRightFinanceData();
			})
		},
		selectdate:function(i){
			var tmpDay = $("#finance_date li[class*='seldate']").attr("data-date");
			var nowday = new Date(tmpDay.substr(0,4)+"-"+tmpDay.substr(4,2)+"-"+tmpDay.substr(6,2));
			var nowweekday = nowday.getDay();
			var tmpSel = nowweekday+i*7-1;
			if(nowweekday==0){
				tmpSel+=7;
			}			
			this.seldate($("#finance_date li").eq(tmpSel).attr("data-date"));
		},
		onLeftFinanceData:function(){
			var self = this;
			var date_width = $(window).width()*0.94;
			var now_left = parseInt($("#finance_date").css("left").replace("px",""));
			now_left = now_left+date_width;	
			var new_left_tmp = now_left+"px";

			if(now_left>20||now_left<date_width*(-2)-10){
				return;
			}
			$("#finance_date").animate({left:new_left_tmp},500,function(){
				var tmp_left = parseInt($("#finance_date").css("left").replace("px",""));
				if(tmp_left>=-5){
					$(".left_btn i").css("display","none");
					$(".right_btn i").css("display","inline-block");
					self.selectdate(0);
				}else if(tmp_left<=date_width*(-2)+20){
					$(".right_btn i").css("display","none");
					$(".left_btn i").css("display","inline-block");
					self.selectdate(2);
				}else{
					$(".left_btn i").css("display","inline-block");
					$(".right_btn i").css("display","inline-block");
					self.selectdate(1);
				}
			});
		},
		onRightFinanceData:function(){
			var self = this;
			var date_width = $(window).width()*0.94;
			var now_left = parseInt($("#finance_date").css("left").replace("px",""));
			now_left = now_left-date_width;	
			var new_left_tmp = now_left+"px";

			if(now_left>20||now_left<date_width*(-2)-10){
				return;
			}
			$("#finance_date").animate({left:new_left_tmp},500,function(){
				var tmp_left = parseInt($("#finance_date").css("left").replace("px",""));
				if(tmp_left>=-5){
					$(".left_btn i").css("display","none");
					$(".right_btn i").css("display","inline-block");
					self.selectdate(0);
				}else if(tmp_left<=date_width*(-2)+20){
					$(".right_btn i").css("display","none");
					$(".left_btn i").css("display","inline-block");
					self.selectdate(2);
				}else{
					$(".left_btn i").css("display","inline-block");
					$(".right_btn i").css("display","inline-block");
					self.selectdate(1);
				}
			});
		},
		moreRoom:function(){
			var json = {
				pid:103
			}
			commonApp.TakingApp("openAppPage",json);
		},
		bindTitleHead:function(){			
			var startpointX=0;
			var starttime=0;			
			var endpointX=0;
			var endtime=0;
			var tmpNowLeft=0;
			var self = this;
			var tmpWidth = 0;
			$(".news_div").show();
			$("#news_ul li").each(function(i,item){
				tmpWidth+=$(this).width()+16;
			});
			$(".news_div").hide();
			$("#news_ul").css({
				"left":0,
				"width":tmpWidth+"px"
			});
			$(".left-zz").hide();
			if(tmpWidth>$(window).width()){
				$(".right-zz").show();
				$("#news_ul").bind("touchstart",function(e){
					startpointX = e.originalEvent.touches[0].clientX;
					tmpNowLeft = parseInt($("#news_ul").css("left").replace("px",""));
					starttime = new Date().valueOf();
				}).bind("touchend",function(e){

				}).bind("touchmove",function(e){
					e.preventDefault();
					var movepointX = e.originalEvent.touches[0].clientX;
					var s = parseInt(movepointX-startpointX);				
					var moveTmp = tmpNowLeft*1+s*1;
					if(moveTmp>0||tmpWidth+moveTmp+60<$(window).width()){
						$(".left-zz").hide();
						return;
					}
					$("#news_ul").css("left",(moveTmp)+"px");					
					$(".left-zz").show();
				});
			}else{
				$(".right-zz").hide();
			}
		},
		showPage:function(id){
			var calendar_read = $("#content_"+id).html();
			var title = $("#title_"+id).text();			
			if(calendar_read!=""){
				calendar_read = JSON.parse(calendar_read);
				calendar_read.title = title;
				calendar_read.id=id;
				$("#part_info_"+id).html(Handlebars.compile($("#interpretationTemplate").html())(calendar_read));
				$(".part_info[id!='part_info_"+id+"']").hide(0);
				if($("#part_info_"+id).css("display")=="none"){
					$("#part_info_"+id).slideDown();	
					this.moveScrollTop(id);
				}else{
					$("#part_info_"+id).slideUp();
				}
			}
		},
		moveScrollTop:function(id){
			var title_height = $("#dataList .data_title").outerHeight();
			var li_num = $("#part_info_"+id).attr("data-index")*1;
			var tmpScrollTop = 0;
			var head_pos = $(".finance_head").css("position");
			if(head_pos=="fixed"){
				$("#dataList li[data-index^='li-']").each(function(i,item){
					if(i<li_num){
						tmpScrollTop+=$(item).outerHeight();
					}
				});				
			}else{
				$("#dataList li[data-index^='li-']").each(function(i,item){
					if(i<=li_num){
						tmpScrollTop+=$(item).outerHeight();
					}
				});				
			}
			tmpScrollTop = tmpScrollTop + $(".scroll").height() + 8;
			$(window).scrollTop(tmpScrollTop);
		},
		hidePage:function(id){
			var self = this;
			$("#part_info_"+id).slideUp(function(){
				self.moveScrollTop(id);
			});
		},
		OpenPage:function(i){
			if(this.bannerList!=null&&this.bannerList!=undefined){
				var url = this.bannerList[i].direct_url
				var type = this.bannerList[i].type;
				var params = {};
				if(this.bannerList[i].params!=null&&this.bannerList[i].params!=undefined&&this.bannerList[i].params!=""){
					params=this.bannerList[i].params;
				}
				commonApp.OpenPage(url,type,params);
			}
		},
		pageReload:function(){
			location.reload();
		},
		openLiveRoom:function(obj){
			var room_id = $(obj).find(".room_img").attr("data-id");//房间号
			var is_common = $(obj).find(".room_img").attr("data-common");//是否是公开房间1公开 -1专属
			var category = $(obj).find(".room_img").attr("data-category");//1是文字2视频
			var status = $(obj).find(".room_img").attr("data-status");//直播室状态休息等
			var roomname = $(obj).find(".room_img").attr("data-roomname");//房间名字
			var authcode = $(obj).find(".room_img").attr("data-authcode");//视频对接使用
			var videohomeid = $(obj).find(".room_img").attr("data-videohomeid");//视频对接使用
			var json ={
				roomid:room_id,
				is_common:is_common,
				pid:104,
				category:category,
				status:status,
				room_name:roomname,
				auth_code:authcode,
				video_home_id:videohomeid
			}
			commonApp.TakingApp("openAppPage",json);
		},
		moreProduct:function(){
			var json ={
				pid:101
			}
			commonApp.TakingApp("openAppPage",json);
		},
		setLiveroomImgHeight:function(){
			var tmpWidth = $(".room_img").width();
			var tmpHeight = tmpWidth/3*2;
			$(".room_img img").height(tmpHeight);
			if($(".room_img").height()*1!=tmpHeight){
				$(".room_img").height(tmpHeight)
			}
			
		},
		loadLocalStorageData:function(){
			//var marketinfo = ls.getItem("marketinfo");

			/*var marketinfo = Tool.getCookie("marketinfo");
			if(marketinfo!=null&&marketinfo!=undefined&&marketinfo!=""){
				$(".market").html(marketinfo);
			}*/
			var liveroom = {
				id:Tool.getCookie("live_id"),
				is_common:Tool.getCookie("live_is_common"),
				category:Tool.getCookie("live_category"),
				status:Tool.getCookie("live_status"),
				room_name:Tool.getCookie("live_room_name"),
				auth_code:Tool.getCookie("live_auth_code"),
				video_home_id:Tool.getCookie("live_video_home_id"),
				room_desc:Tool.getCookie("live_room_desc"),
				online_num:Tool.getCookie("live_online_num"),
				room_mobile_icon:"../images/room_def.png"
			}
			var wordroom = {
				id:Tool.getCookie("word_id"),
				is_common:Tool.getCookie("word_is_common"),
				category:Tool.getCookie("word_category"),
				status:Tool.getCookie("word_status"),
				room_name:Tool.getCookie("word_room_name"),
				auth_code:Tool.getCookie("word_auth_code"),
				video_home_id:Tool.getCookie("word_video_home_id"),
				room_desc:Tool.getCookie("word_room_desc"),
				online_num:Tool.getCookie("word_online_num"),
				room_mobile_icon:"../images/room_def.png"
			}
			$("#video_room").html(Handlebars.compile($("#videoTemplate").html())(liveroom));
			$("#word_room").html(Handlebars.compile($("#wordTemplate").html())(wordroom));
			this.setLiveroomImgHeight();
		},
		setScrollHeight:function(){
			if($("#scroll_img").height()!=0){
				$("#scroll_img").height($("#scroll_img").height())
			}
		}
	}

	module.exports={
		commonApp:commonApp,
		appIndex:appIndex
	};
})
