define(function(require,exports,module){
	var $=require("jquery");
	var tool=require("tool")   ;
	function Tab($titles,$contents,fns,config){
		if(!(this instanceof Tab)){
			return new Tab(titles,contents,config);
		}
		this.$titles=$titles;
		this.$contents=$contents;
		config=config||{};
		this.config=tool.extend(this.defaultConfig,config);
		this.fns=fns||[];
		this.initedContent={};
		this.init();
	}

	Tab.prototype={
		constructor:Tab,
		defaultConfig:{
			curTab:0,
			activeClass:"tab_active",
			disActiceClass:"tab_disActive",
			hideClass:"tab_hide",
			showClass:"tab_show",
			triggerEvent:"click",
			autoInit:true,
			initContentAlways:false,
			relation:[]
		},

		init:function(){
			var config=this.config;
			this.bindEvent();
			if(config.autoInit){
				this.switchTab(this.config.curTab);
			}
		},

		switchTab:function(tabIndex){
			var self=this,config=this.config;
			var needSwitch=true;
			var $title=$(this.$titles[tabIndex]);
			var content=self.$contents[tabIndex];
			if(self.fns[tabIndex]){
				if(config.initContentAlways==false){
					if(!self.initedContent[tabIndex]){
						needSwitch=self.fns[tabIndex]($title,content&&$(content),tabIndex)!==false;
					}
				}else{
					needSwitch=self.fns[tabIndex]($title,content&&$(content),tabIndex)!==false;
				}
			}
			if(!needSwitch){
				return false;
			}

			self.initedContent[tabIndex]=true;

			this.$titles.each(function(index,item){
				var $title=$(item);
				var tmpIndex = index;
				if(self.config.relation.length != 0){
					tmpIndex = self.config.relation[index];
				}
				var content=self.$contents[tmpIndex];
				if(tmpIndex==tabIndex){
					$title.addClass(config.activeClass).removeClass(config.disActiceClass);
					if(content){
						$(content).addClass(config.showClass).removeClass(config.hideClass);
					}
					config.curTab=tmpIndex;
				}else{
					$title.addClass(config.disActiceClass).removeClass(config.activeClass);
					if(content){
						$(content).addClass(config.hideClass).removeClass(config.showClass)
					}
				}
			})

			return true;
		},

		bindEvent:function(){
			var self=this;
			this.$titles.bind(this.config.triggerEvent,function(){
				var index=self.$titles.index($(this));
				self.switchTab(index);
			})
		}
	}

	module.exports=Tab;
})