define(function(require,exports,module){
	var Handlebars=require("core/Handlebars");
	var tool=require("tool");
	var $ = require("jquery");
	Handlebars.registerHelper("compare",function(){
	    var operators=["+","-","*","/","=","==","===","!=","!==","&&","||","!","&","|","^","-","(",")",">",">=","<","<=","%"],operatorsLen=operators.length;
	    var args=[].splice.call(arguments,0,arguments.length);
	    var options=args.splice(-1,1)[0];
	    var fnString="",fn;
	    $.each(args,function(index,item){
	        var isOperator=false;
	        for(var i=0;i<operatorsLen;i++){
	            if(operators[i]==$.trim(item)){
	                isOperator=true;
	                break;
	            }
	        }
	        if((typeof item =="string")&&!isOperator){
	            fnString+="'"+item+"'";
	        }else{
	            fnString+=item;
	        }
	    })
	    try{
	        fn=new Function( "return "+fnString+";");
	    }catch(err){
	        throw new Error("compare 的参数不能构成函数");
	    }
	    if(options.fn){
	        if(!!fn()){
	            return options.fn(this);
	        }else{
	            return options.inverse(this);
	        }
	    }else{
	        return fn();
	    }
	});

	
	Handlebars.registerHelper("showPage",function(curPage,firstPage,lastPage,options){
		var html="",tempData;
		while(firstPage<=lastPage){
			tempData={
				page:firstPage,
				isCurPage:firstPage==curPage
			}
			html+=options.fn(tempData);
			firstPage++;
		}
		return html;
	});

	Handlebars.registerHelper("toFixed",function(number,point){
		return parseFloat(number).toFixed(point);
	});

	Handlebars.registerHelper("showTime",function(time,format,level){
		if(typeof level == "number"){
			time = time*level;
		}
		if(!time){
			return "";
		}
		if(typeof time == "number"){
			time=new Date(time);
		}
		if(!(time instanceof Date)){
			time=new Date(tool.getTimeFromString(time));
		}
		if(!(time instanceof Date)){
			return "";
		}
		var year=time.getFullYear(),month=time.getMonth()+1,date=time.getDate(),hours=time.getHours(),minutes=time.getMinutes(),seconds=time.getSeconds(),result;
		result=format.replace(/YYYY/gi,year)
			.replace(/YY/gi,addZero(year%100))
			.replace(/MM/g,addZero(month))
			.replace(/M/g,month)
			.replace(/DD/g,addZero(date))
			.replace(/D/g,date)
			.replace(/HH/gi,addZero(hours))
			.replace(/H/gi,hours)
			.replace(/mm/g,addZero(minutes))
			.replace(/m/g,minutes)
			.replace(/SS/gi,addZero(seconds))
			.replace(/S/gi,seconds);

		return result;

		function addZero(num){
			if(parseInt(num)<10){
				num="0"+num;
			}
			return num;
		}
	});

	Handlebars.registerHelper("showlevel",function(level){
	    var levelname = "";
	    level = parseInt(level);
	    switch (level) {
	        case 1:
	            levelname = "一";
	            break;
	        case 2:
	            levelname = "二";
	            break;
	        case 3:
	            levelname = "三";
	            break;
	        case 4:
	            levelname = "四";
	            break;
	    }
	    return levelname;
	});

	Handlebars.registerHelper("changeFund",function(str){
		var fund = 1;
		if(str=="0-5w"){
			fund = 1;
		}else if(str=="5-10w"){
			fund = 2;
		}else if(str=="10-30w"){
			fund = 3;
		}else if(str=="30-50w"){
			fund = 4;
		}else if(str=="50-100w"){
			fund = 5;
		}else if(str=="100w以上"){
			fund = 6;
		}
		return fund;
	});

	Handlebars.registerHelper("changeRate",function(str){
		var rate = 0;
		if(str==null||str==undefined){
			return rate;
		}
		if(str.indexOf("A")>=0){
			rate = 10;
		}else if(str.indexOf("B")>=0){
			rate = 20;
		}else if(str.indexOf("C")>=0){
			rate = 30;
		}
		return rate;
	});

	Handlebars.registerHelper("isCustomerService",function(str){
		if(str!="客服"){
			str = "["+str+"]";
		}
		return str;
	});

	Handlebars.registerHelper("importantclass",function(str){
		if(str==3){
			str="high";
		}else if(str==2){
			str="middle";
		}else if(str==1){
			str="low";
		}
		return str;
	});

	Handlebars.registerHelper("getJsonString",function(str,obj){
		var tmp = JSON.parse(str);
		return tmp[obj];
	});

	Handlebars.registerHelper("getCountryName",function(str){
		var nameList = {
			"中国":"china",
			"台湾":"china",
			"澳洲":"australia",
			"澳大利亚":"australia",
			"德国":"germany",
			"法国":"france",
			"韩国":"korea",
			"加拿大":"canada",
			"美国":"usa",
			"欧洲":"eu",
			"欧盟":"eu",
			"欧元":"eu",
			"欧元区":"eu",
			"日本":"japan",
			"瑞士":"switzerland",
			"香港":"hongkong",
			"新加坡":"singapore",
			"新西兰":"newzealand",
			"意大利":"italy",
			"英国":"britain",
			"南非":"southafrica",
			"巴西":"brazil",
			"俄罗斯":"russia",
			"印度":"india",
			"印尼":"indonesia",
			"印度尼西亚":"indonesia",
			"西班牙":"spain",
			"葡萄牙":"portugal",
			"比利时":"belgium",
			"爱尔兰":"ireland",
			"希腊":"hellenic",
			"挪威":"norway",
			"土耳其":"turkey",
			"瑞典":"sweden",
			"奥地利":"austria",
			"匈牙利":"hungary",
			"芬兰":"finland",
			"智利":"chile",
			"拉脱维亚":"latvia",
			"墨西哥":"mexico",
			"卢森堡":"luxembourg",
			"捷克":"czech",
			"冰岛":"iceland",
			"荷兰":"netherland",
			"秘鲁":"peru",
			"OECD":"oecd",
			"阿联酋":"arab"
		}

		var name = "nofound";
		for(var key in nameList){
			if(key==str){
				name = nameList[key];
			}
		}
		return name;
	});

	Handlebars.registerHelper("showurl",function(id,date){
		return location.origin+"/news/mobile/finance/"+date+"#"+id;
	})

	Handlebars.registerHelper("opennewsdialog",function(id,isClient){		
		var newurl = "gw://webkitdlg?width=800;height=600;resize=0;title=资讯;url="+location.origin+"/news/index/content.html?id[equal]"+id;
		if(isClient==false){
			newurl = location.origin+"/news/index/content.html?id="+id;
		}
		return newurl;
	})

	Handlebars.registerHelper("trend",function(obj){
		if(obj*1==1){
			return "利多";
		}else{
			return "利空";
		}
	})

	Handlebars.registerHelper("isIE",function(obj){
		if (!!window.ActiveXObject || "ActiveXObject" in window){
			return "wd100";
		}else{
			return "wd60";
		}
	})

	Handlebars.registerHelper("removebar",function(title){
		title = title.replace(/^-*/g,"");
		return title;
	})

	Handlebars.registerHelper("jsonToString",function(obj){
		var str = "";
		if(obj){
			str = JSON.stringify(obj);
		}
		return str;
	})

	Handlebars.registerHelper("liveStart",function(status){
		if(status*1==1||status*1==-2){
			return "直播中";
		}
		return "休息中";
	})

	Handlebars.registerHelper("liveStartClass",function(status){
		if(status*1==1||status*1==-2){
			return "room_living";
		}
		return "room_noliving";
	})

	Handlebars.registerHelper("seeThing",function(num){
		if(num==1){
			return "利多金银"
		}else if(num==2){
			return "利空金银";
		}else if(num==3){
			return "影响较小";
		}
		return "";
	})

	module.exports=Handlebars;
})