define(function(require,exports,module){
	var tool={

		inherit:function(subClass,superClass){
			var fn=function(){};
			fn.prototype=superClass.prototype;
			subClass.prototype=new fn();
			subClass.prototype.constructor=subClass;
			subClass.superClass=superClass.prototype;  
			if(superClass.prototype.constructor==Object.prototype.constructor){
				superClass.prototype.constructor=superClass;
			}
		},

		getParent:function(target,flag,deep){
			var i=0;
			while(target&&target!=document&&target.getAttribute(flag)===null){
				target=target.parentNode;
				if(deep&&i>deep){
					break;
				}
				i++;
			}
			if(target&&target!=document&&target.getAttribute(flag)!==null){
				return target;
			}else{
				return null;
			}
		},

		trim:function(string){
			if(string.trim){
				return string.trim();
			}else{
				return string.replace(/^\s+|\s+$/g,"");
			}
		},

		createDate:function(string,spliter){
			var timeArray=[],tempArray=Tool.trim(string).split(/\s+/);
			timeArray=timeArray.concat(tempArray[0].split(spliter||"-"));
			if(timeArray[1]){
				timeArray=timeArray.concat(tempArray[1].split(":"));
			}
			return Date.UTC.apply(timeArray);
		},

		extend:function(from,to,force){
			for(var name in from){
				if(from.hasOwnProperty(name)&&!(name in to)||force){
					to[name]=from[name];
				}
			}
			return to;
		},

		reverseEle:function(eleArray){
			var l=eleArray.length;
			if(l<2){
				return;
			}
			var parentNode=eleArray[0].parentNode;
			l-=1;
			while(l--){
				parentNode.appendChild(eleArray[l]);
			}
		},
		
		parseURL:function(url) {
			var paraString = url.substring(url.indexOf("?") + 1, url.length).split("&");
			var paraObj = {}
			for (i = 0; j = paraString[i]; i++) {
				paraObj[j.substring(0, j.indexOf("=")).toLowerCase()] = decodeURIComponent(j.substring(j.indexOf("=") + 1, j.length));
			}
			return paraObj;
		},
		//pos-1时表示向下滚到底。否则够到固定位置
		scrollPosition:function($outer,$inner,pos,time){
			if(pos==-1){
				var gap=$inner.outerHeight()-$outer.height();
			}else{
				gap=pos;
			}
			$outer.animate({scrollTop:gap},time||0);
		},
		getTimeFromString:function(timeString){
			if(parseInt(timeString)==timeString*1){
				return new Date(timeString*1);
			}
			var date=timeString.split(" ");
			var dateArray=date[0].split("-");
			dateArray[1]=dateArray[1]-1;
			if(date[1]){
				var tempArray=date[1].split(":");
				tempArray[0]-=8;
				dateArray=dateArray.concat(tempArray);
			}
			return Date.UTC.apply(null,dateArray);
		},
		characterChange:function(string){
			//部分需要替换的键值
			var characterList = {
				"&quot;":"\"",
				"&amp;":"&",
				"&lt;":"<",
				"&gt;":">",
				"&lsquo;":"‘",
				"&rsquo;":"’",
				"&sbquo;":"‚",
				"&ldquo;":"“",
				"&rdquo;":"”",
				"&permil;":"‰",
				"&copy;":"©",
				"&reg;":"®",
				"&times;":"×",
				"&divide;":"÷"
			}
			var tmpStr = string;
			for(var key in characterList){
				tmpStr = tmpStr.replace(eval("/"+key+"/g"),characterList[key]);
			}
			return tmpStr;
		},
		getPageObj:function(curPage,totalPage){
			curPage=parseInt(curPage);
			var renderObj={
				totalPage:totalPage,
				curPage:curPage,
				startPage:1,
				lastPage:1,
				displayPrevBtn:false,
				displayNextBtn:false,
				prevPage:1,
				nextPage:1
			}
			renderObj.startPage=(curPage-3>0)?curPage-3:1;
			renderObj.lastPage=(curPage+3>totalPage)?totalPage:curPage+3;
			renderObj.displayPrevBtn=curPage>renderObj.startPage;
			renderObj.displayNextBtn=curPage<renderObj.lastPage;
			if(renderObj.displayNextBtn){
				renderObj.nextPage=curPage+1;
			}
			if(renderObj.displayPrevBtn){
				renderObj.prevPage=curPage-1;
			}
			return renderObj;
		},
		loadScript:function(url, callback){
			var script = document.createElement("script")
			script.type = "text/javascript";
			if (script.readyState){ //IE
				script.onreadystatechange = function(){
					if (script.readyState == "loaded" || script.readyState == "complete"){
						script.onreadystatechange = null;
						if(callback){
						callback();
					    }
					}
				};
			} 
			else { //Others: Firefox, Safari, Chrome, and Opera
				script.onload = function(){
					if(callback){
					callback();
					}
				};
			}
			script.src = url;
			document.body.appendChild(script);
		},
		//生成临时id
		createTempId:(function(){
			var i=1;
			return function(){
				return "temp"+(i++);
			}
		})(),
		getEndDate:function(startDate, day, type){
			var endDate = "";
			var stdate = new Date(startDate).valueOf();
			addday = day * 1000 * 3600 * 24;
			if (type * 1 == 0) {
				endatestr = stdate - addday;
			} else {
				endatestr = stdate + addday;
			}
			var endate = new Date(endatestr);

			var y = endate.getFullYear();
			var m = endate.getMonth() + 1;
			var d = endate.getDate();

			if (m <= 9) {
				m = "0" + m;
			}
			if (d <= 9) {
				d = "0" + d;
			}
			endDate = y + "" + m + "" + d;
			return endDate;
		},
		getWeekDay:function(date){
			var nowdate = new Date(date);
			var tmpday = nowdate.getDay();
			var weekday = "";
			if(tmpday==0){
				weekday = weekday + "日";
			}else if(tmpday==1){
				weekday = weekday + "一";
			}else if(tmpday==2){
				weekday = weekday + "二";
			}else if(tmpday==3){
				weekday = weekday + "三";
			}else if(tmpday==4){
				weekday = weekday + "四";
			}else if(tmpday==5){
				weekday = weekday + "五";
			}else if(tmpday==6){
				weekday = weekday + "六";
			}
			return weekday;
		},
		urlImageToBase64:function(imgUrl,fun){ //只能是在同一域名下，跨域要求服务器设置
			var canvas = document.createElement('CANVAS'); 
			var ctx = canvas.getContext('2d');
			var img = new Image;
			img.crossOrigin = 'Anonymous'; 
			img.onload = function(){ 
				canvas.height = img.height; 
				canvas.width = img.width; 
				ctx.drawImage(img,0,0);
				var dataURL = canvas.toDataURL();
				fun.call(this,dataURL);
				canvas = null;
			};
			img.src = imgUrl;
		},
		setCookie:function(name,value){
			var date = new Date();
			var expireDays = 10;
			date.setTime(date.getTime()+expireDays*24*3600*1000);
			document.cookie = name + "=" + escape(value)+";expire="+date.toGMTString();
		},
		getCookie:function(name){
			var arr,reg=new RegExp("(^| )"+name+"=([^;]*)(;|$)");
			if(arr=document.cookie.match(reg)){
				return unescape(arr[2]);
			}else{
				return null;
			}
		}
	};
	module.exports=tool;
})